Added second ROC test
authorJohn Darrington <john@darrington.wattle.id.au>
Wed, 24 Jun 2009 08:47:38 +0000 (16:47 +0800)
committerJohn Darrington <john@darrington.wattle.id.au>
Wed, 24 Jun 2009 08:47:38 +0000 (16:47 +0800)
src/language/stats/roc.c
tests/automake.mk
tests/command/roc2.sh [new file with mode: 0755]

index eae528a38a81c126b30c5ffa9a66b93212293011..88f954044f2122c6ae64be9f20093719b522de13 100644 (file)
@@ -640,6 +640,13 @@ do_roc (struct cmd_roc *roc, struct casereader *input, struct dictionary *dict)
       n_neg = process_negative_group (var, neg, dict, &rs[i]);
 
 
+      printf ("Positives:\n");
+      dump_casereader (n_pos);
+
+      printf ("Negatives:\n");
+      dump_casereader (n_neg);
+
+#if 0
       /* Simple join on VALUE */
       for ( ; (cpos = casereader_read (n_pos) ); case_unref (cpos))
        {
@@ -690,6 +697,7 @@ do_roc (struct cmd_roc *roc, struct casereader *input, struct dictionary *dict)
          rs[i].q2hat /= rs[i].n1 * pow2 (rs[i].n2);
        }
     }
+#endif
 
   casereader_destroy (positives);
   casereader_destroy (negatives);
index 9824a9fe9dfbda575f93fcec46535399836d4d11..aba1a62c1170580a185b5f6ca2b39042e48a1ef1 100644 (file)
@@ -57,6 +57,7 @@ dist_TESTS = \
        tests/command/regression-qr.sh \
        tests/command/reliability.sh \
        tests/command/roc.sh \
+       tests/command/roc2.sh \
        tests/command/sample.sh \
        tests/command/sort.sh \
        tests/command/sysfiles.sh \
diff --git a/tests/command/roc2.sh b/tests/command/roc2.sh
new file mode 100755 (executable)
index 0000000..0857274
--- /dev/null
@@ -0,0 +1,96 @@
+#!/bin/sh
+
+# This program tests  the ROC command.
+
+TEMPDIR=/tmp/pspp-tst-$$
+TESTFILE=$TEMPDIR/`basename $0`.sps
+
+# ensure that top_builddir  are absolute
+if [ -z "$top_builddir" ] ; then top_builddir=. ; fi
+if [ -z "$top_srcdir" ] ; then top_srcdir=. ; fi
+top_builddir=`cd $top_builddir; pwd`
+PSPP=$top_builddir/src/ui/terminal/pspp
+
+# ensure that top_srcdir is absolute
+top_srcdir=`cd $top_srcdir; pwd`
+
+STAT_CONFIG_PATH=$top_srcdir/config
+export STAT_CONFIG_PATH
+
+LANG=C
+export LANG
+
+cleanup()
+{
+     if [ x"$PSPP_TEST_NO_CLEANUP" != x ] ; then 
+       echo "NOT cleaning $TEMPDIR" 
+       return ; 
+     fi
+     cd /
+     rm -rf $TEMPDIR
+}
+
+
+fail()
+{
+    echo $activity
+    echo FAILED
+    cleanup;
+    exit 1;
+}
+
+
+no_result()
+{
+    echo $activity
+    echo NO RESULT;
+    cleanup;
+    exit 2;
+}
+
+pass()
+{
+    cleanup;
+    exit 0;
+}
+
+mkdir -p $TEMPDIR
+
+cd $TEMPDIR
+
+activity="create program"
+cat > $TESTFILE <<EOF
+set format F10.3.
+data list notable list /x * a *.
+
+begin data.
+0 0
+1 1
+2 0
+3 1
+4 0
+5 1
+6 0
+7 1
+8 0
+9 1
+9 0
+9 1
+end data.
+
+roc x by a (1).
+EOF
+if [ $? -ne 0 ] ; then no_result ; fi
+
+activity="run program"
+$SUPERVISOR $PSPP --testing-mode $TESTFILE
+if [ $? -ne 0 ] ; then no_result ; fi
+
+
+activity="compare results"
+perl -pi -e 's/^\s*$//g' $TEMPDIR/pspp.list
+diff -b  $TEMPDIR/pspp.list - << EOF
+EOF
+if [ $? -ne 0 ] ; then fail ; fi
+
+pass